import * as fsgit from "fs-git";
import * as pmb from "packagemanager-backend";
import * as m from "./model";
import Tracker from "./tracker";
export declare function createManager(options?: m.Options): Promise<Manager>;
export default class Manager {
    static defaultConfigFile: string;
    static defaultRootDir: string;
    static defaultRepo: string;
    static defaultRef: string;
    static defaultPath: string;
    static defaultBundleFile: string;
    configPath: string;
    offline: boolean;
    rootDir: string;
    repos: pmb.RepositorySpec[];
    path: string;
    bundle: string;
    backend: pmb.Manager<m.GlobalConfig>;
    tracker: Tracker;
    savedRecipe: m.Recipe;
    constructor(options?: m.Options);
    init(path?: string): string;
    search(phrase: string): Promise<pmb.SearchResult[]>;
    install(opts: {
        save: boolean;
        dryRun: boolean;
    }, phrases: string[]): Promise<pmb.Result>;
    installFromFile(opts?: {
        dryRun?: boolean;
    }, retryWithFetch?: boolean): Promise<pmb.Result>;
    update(opts: {
        save?: boolean;
        dryRun?: boolean;
    }): Promise<pmb.Result>;
    uninstall(opts: {
        save?: boolean;
        dryRun?: boolean;
    }, phrases: string[]): Promise<pmb.ResolvedDependency[]>;
    link(opts: {
        save?: boolean;
        dryRun?: boolean;
    }): Promise<m.LinkResult[]>;
    refs(): Promise<fsgit.RefInfo[]>;
    fetch(): Promise<void>;
}
